#!/bin/sh

cd `dirname $0`
BUNDLE_HOME=`(cd ../.. ; pwd)`

SYNCSERVER_HOME=`(cd ${BUNDLE_HOME}/ds-server ; pwd)`

export JAVA_HOME=${BUNDLE_HOME}/tools/jre-1.5.0/jre
export J2EE_HOME=${BUNDLE_HOME}/tools/tomcat
export CATALINA_HOME=${BUNDLE_HOME}/tools/tomcat

cd ${BUNDLE_HOME}

if [ -z ${J2EE_HOME} ]
then
    echo "ERROR: ${BUNDLE_HOME} does not seem to a valid Funambol bundle (missing ${J2EE_HOME})."
    exit;
fi

if [ -z ${CATALINA_HOME} ]
then
    echo "ERROR: ${CATALINA_HOME} does not seem to a valid Funambol bundle (missing ${CATALINA_HOME})."
    exit;
fi

if [ -z ${JAVA_HOME} ]
then
    echo "ERROR: ${BUNDLE_HOME} does not seem to a valid Funambol bundle (missing ${JAVA_HOME})."
    exit;
fi

if [ ! -f tools/bin/funambol.sh ]
then
    echo "ERROR: ${BUNDLE_HOME} does not seem to a valid Funambol bundle (missing tools/bin/funambol.sh)."
    exit;
fi

#
# Other settings
#
export JAVA_OPTS="$JAVA_OPTS -Dfunambol.ds.home=${SYNCSERVER_HOME}"
export JPDA_OPTS="-Xdebug -Xrunjdwp:transport=dt_socket,address=8787,server=y,suspend=n"

export LANG=en_US.utf-8

cd ${J2EE_HOME}/bin


case $1 in 
start)
    #
    # Run Hypersonic
    #
    ${JAVA_HOME}/bin/java org.hsqldb.Server -database.0 ${BUNDLE_HOME}/tools/hypersonic/data/funambol -dbname.0 funambol > /dev/null &

    #
    # Run Tomcat for normal use
    #
    ./catalina.sh start > /dev/null

    #
    # Run Tomcat for debug
    #
    #./catalina.sh jpda start
    #!/bin/sh
    ;;
stop)
    #
    # Shutdown Tomcat
    #
    cd ${J2EE_HOME}/bin
    ./shutdown.sh > /dev/null

    #
    # Shutdown Hypersonic
    #
    ${JAVA_HOME}/bin/java org.hsqldb.util.ShutdownServer -port -user sa -url jdbc:hsqldb:hsql://localhost/funambol -shutdownarg IMMEDIATELY
    ;;
*)
    echo "usage: $0 [start~stop]"
    ;;
esac

