#!/bin/sh

version=$1
tempfile=$2

if test "x$version" = "x" ; then
    echo " "
    echo "usage: $0 <version>"
    echo " "
    exit;
fi

cd `dirname $0`/../../..

export FORGE_HOME=`pwd`
export J2EE_HOME=${FORGE_HOME}/output/Funambol/tools/tomcat
export APPSRV=tomcat

if [ ! -d ${FORGE_HOME}/output ]
then 
    echo "No output directory found: nothing to do."
    exit;
fi

cd ${FORGE_HOME}/output

if [ ! -d Funambol ]
then
    echo "No Funambol directory found: nothing to do."
    exit;
fi

if [ -f "Funambol/Funambol Web Site.url" ]
then
    rm "Funambol/Funambol Web Site.url"
fi

if [ -f "Funambol/pimweb-demo.url" ]
then
    rm "Funambol/pimweb-demo.url"
fi

if [ -f "Funambol/admin/funambol.url" ]
then
    rm "Funambol/admin/funambol.url"
fi

#
# Now we set execution permission to the relevant files.
#
chmod +x Funambol/tools/bin/*
chmod +x Funambol/tools/jre-1.5.0/jre/bin/*
chmod +x Funambol/tools/tomcat/bin/*
chmod +x Funambol/ds-server/bin/*
chmod +x Funambol/admin/bin/*
chmod +x Funambol/plug-ins/java-gui/*.sh
chmod +x Funambol/ds-server/ant/bin/*

#
# Tarring
#
echo "Archiving..."
tar cvzf ${tempfile} Funambol

#
# Checksumming
#
echo "Checksumming..."
SUM=`sum ${tempfile}`

cp ${FORGE_HOME}/output/linux/head funambol-$version.bin
echo " " >>funambol-$version.bin
echo "#" >>funambol-$version.bin
echo "# TO UPDATE EVERYTIME" >>funambol-$version.bin
echo "#" >>funambol-$version.bin
echo "packageName=Funambol" >>funambol-$version.bin
echo "diskSpaceRequired=120000" >>funambol-$version.bin
echo "pkgSum=\"$SUM\"" >>funambol-$version.bin
echo "destDir=." >>funambol-$version.bin
echo "startingLine=481" >>funambol-$version.bin
echo "###" >>funambol-$version.bin
echo " " >>funambol-$version.bin
cat ${FORGE_HOME}/output/linux/tail >>funambol-$version.bin
# The following line cannot be added if the tail file has already and
# EOL as the last line. Some editors add one, some strip,...
#echo "" >>funambol-$version.bin
cat ${tempfile} >> funambol-$version.bin
