#!/bin/sh

#
# Set JAVA_HOME and J2EE_HOME before running this script.
#
# set JAVA_HOME to the path where you have Java 2 installed.
#
# set J2EE_HOME to the path where you have installed this package (EJB server).
#

if [ -z $JAVA_HOME ]
then
    echo "Please, set JAVA_HOME before running this script."
    exit;
fi

if [ -z $J2EE_HOME ]
then
    echo "Please, set J2EE_HOME before running this script."
    exit;
fi

if [ ! -f bin/start.sh ]
then
    echo "Please start this script from the SyncServer home directory."
    exit;
fi

#
# Other settings
#
export LANG=en_US.utf-8

FUNAMBOL_HOME=$PWD
JAVA_OPTS="-Dfunambol.ds.home=$FUNAMBOL_HOME"
#
# Uncomment the following line to enable remote debugging
#
#JAVA_OPTS="-classic -Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=8787,server=y,suspend=n $JAVA_OPTS"

export JAVA_OPTS;

export JBOSS_CLASSPATH="{driver.jarfile}"

#
# Run JBoss
#
cd $J2EE_HOME/bin

./run.sh -c funambol

