/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.funambol.framework.engine;

import com.funambol.framework.core.StatusCode; // Mmmhh.... is this a good dependency?

/**
 *
 *
 * @version $Id: SyncException.java,v 1.1 2006/01/18 17:00:07 luigiafassina Exp $
 */
public class SyncException extends java.lang.Exception {

    // ------------------------------------------------------------ Private data

    private int statusCode;

    // ------------------------------------------------------------ Constructors

    public SyncException(String msg) {
        this(msg, null, StatusCode.PROCESSING_ERROR);
    }

    public SyncException(String msg, int statusCode) {
        this(msg, null, statusCode);

    }

    public SyncException(String msg, Throwable cause) {
        this(msg, cause, StatusCode.PROCESSING_ERROR);
    }

    public SyncException(String msg, Throwable cause, int statusCode) {
        super(msg, cause);
        this.statusCode = statusCode;
    }

    public SyncException(Throwable cause) {
        this(cause.getMessage(), cause, StatusCode.PROCESSING_ERROR);
    }

    // ---------------------------------------------------------- Public methods

    public int getStatusCode() {
        return statusCode;
    }
}
