/**
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.framework.filter;

import java.io.Serializable;

/**
 * This class recognize the clause of type logical for the filter.
 * For logical clause mean AND, OR, NOT clause.
 *
 * @version $Id: FilterClause.java,v 1.1 2006/01/18 17:00:07 luigiafassina Exp $
 */
public class FilterClause implements Serializable {

    // --------------------------------------------------------------- Constants

    // ------------------------------------------------------------ Private data

    /**
     * The clause
     */
    private LogicalClause clause;

    private boolean inclusive = false;


    // ----------------------------------------------------------- Getter/Setter
    public void setInclusive(boolean isInclusive) {
        this.inclusive = isInclusive;
    }

    public boolean isInclusive() {
        return inclusive;
    }

    public boolean isExclusive() {
        return !inclusive;
    }

    public void setClause(LogicalClause clause) {
        this.clause = clause;
    }

    public LogicalClause getClause() {
        return clause;
    }

}
