/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.framework.server;

import com.funambol.framework.core.DevInf;

import java.io.Serializable;

/**
 * This class represents a phone's capabilities
 *
 * @version $Id: Capabilities.java,v 1.1 2006/01/18 17:00:08 luigiafassina Exp $
 */

    // ------------------------------------------------------------ Private data
public class Capabilities implements Serializable {

    private Integer id;
    private DevInf devInf;

    // ------------------------------------------------------------- Costructors

    /** Creates a new instance of Capabilities */
    public Capabilities() {
        this.id     = null;
        this.devInf = null;
    }

    /**
     * Creates a new instance of Capabilities
     * @param id the capabilities identificatin number
     * @param devInf informations about device's capabilities
     */
    public Capabilities(Integer id, DevInf devInf) {
        this.id     = id;
        this.devInf = devInf;
    }

    /**
     * Getter for the id property.
     * @return value of property id
     */
    public Integer getId() {
        return id;
    }

    /**
     * Setter for the id property
     * @param id New value of id property
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * Getter for the devInf property
     * @return value of the devInf property
     */
    public DevInf getDevInf() {
        return devInf;
    }

    /**
     * Setter for the devInf property
     * @param devInf New value of the devInf property
     */
    public void setDevInf(DevInf devInf) {
        this.devInf = devInf;
    }

}
