/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.server.config;

/**
 *
 * This class is just a container of SyncServer engine configuration.
 *
 *
 * @version $Id: EngineConfiguration.java,v 1.1 2006/01/18 17:00:11 luigiafassina Exp $
 */
public class EngineConfiguration {

    // ------------------------------------------------------------ Private data

    /**
     * The server URI
     */
    private String serverURI;

    /**
     * The SyncStrategy implementation to use
     */
    private String strategy;

    /**
     * The SessionHandler to use
     */
    private String sessionHandler;

    /**
     * The PersistentStore to use
     */
    private String store;

    /**
     * The SecurityOfficer to use
     */
    private String officer;

    /**
     * The PipelineManager to use
     */
    private String pipelineManager;

    /**
     * The UserManager to use
     */
    private String userManager;

    /**
     * The LoggingConfiguration to use
     */
    private String loggingConfiguration;

    /**
     * The minimum MaxMsgSize allowed
     */
    private long minMaxMsgSize;

    /**
     * The DeviceInventory to use
     */
    private String deviceInventory;

    /**
     * The DataTransformerManager to use
     */
    private String dataTransformerManager;

    // ---------------------------------------------------------- Public methods

    /**
     * Getter for property serverURI.
     * @return Value of property serverURI.
     */
    public String getServerURI() {
        return serverURI;
    }

    /**
     * Setter for property serverURI.
     * @param serverURI New value of property serverURI.
     */
    public void setServerURI(String serverURI) {
        this.serverURI = serverURI;
    }

    /**
     * Getter for property strategy.
     * @return Value of property strategy.
     */
    public String getStrategy() {
        return strategy;
    }

    /**
     * Setter for property strategy.
     * @param strategy New value of property strategy.
     */
    public void setStrategy(String strategy) {
        this.strategy = strategy;
    }

    /**
     * Getter for property sessionHandler.
     * @return Value of property sessionHandler.
     */
    public String getSessionHandler() {
        return sessionHandler;
    }

    /**
     * Setter for property sessionHandler.
     * @param sessionHandler New value of property sessionHandler.
     */
    public void setSessionHandler(String sessionHandler) {
        this.sessionHandler = sessionHandler;
    }

    /**
     * Getter for property store.
     * @return Value of property store.
     */
    public String getStore() {
        return store;
    }

    /**
     * Setter for property store.
     * @param store New value of property store.
     */
    public void setStore(String store) {
        this.store = store;
    }

    /**
     * Getter for property officer.
     * @return Value of property officer.
     */
    public String getOfficer() {
        return officer;
    }

    /**
     * Setter for property officer.
     * @param officer New value of property officer.
     */
    public void setOfficer(String officer) {
        this.officer = officer;
    }

    /**
     * Getter for property pipelineManager.
     * @return Value of property pipelineManager.
     */
    public String getPipelineManager() {
        return pipelineManager;
    }

    /**
     * Setter for property pipelineManager.
     * @param pipelineManager New value of property pipelineManager.
     */
    public void setPipelineManager(String pipelineManager) {
        this.pipelineManager = pipelineManager;
    }

    /**
     * Getter for property userManager.
     * @return Value of property userManager.
     */
    public String getUserManager() {
        return userManager;
    }

    /**
     * Setter for property userManager.
     * @param userManager New value of property userManager.
     */
    public void setUserManager(String userManager) {
        this.userManager = userManager;
    }

    /**
     * Getter for property loggingConfiguration.
     * @return Value of property loggingConfiguration.
     */
    public String getLoggingConfiguration() {
        return loggingConfiguration;
    }

    /**
     * Setter for property loggingConfiguration.
     * @param loggingConfiguration the new value of property loggingConfiguration.
     */
    public void setLoggingConfiguration(String loggingConfiguration) {
        this.loggingConfiguration = loggingConfiguration;
    }

    /**
     * Getter for property minMaxMsgSize.
     * @return Value of property minMaxMsgSize.
     */
    public long getMinMaxMsgSize() {
        return minMaxMsgSize;
    }

    /**
     * Setter for property minMaxMsgSize.
     * @param minMaxMsgSize New value of property minMaxMsgSize.
     */
    public void setMinMaxMsgSize(long minMaxMsgSize) {
        this.minMaxMsgSize = minMaxMsgSize;
    }


    /**
     * Getter for property deviceInventory.
     * @return Value of property deviceInventory.
     */
    public String getDeviceInventory() {
        return deviceInventory;
    }

    /**
     * Setter for property deviceInventory.
     * @param deviceInventory New value of property deviceInventory.
     */
    public void setDeviceInventory(String deviceInventory) {
        this.deviceInventory = deviceInventory;
    }

    /**
     * Getter for property dataTransformerManager.
     * @return Value of property dataTransformerManager.
     */
    public String getDataTransformerManager() {
        return dataTransformerManager;
    }

    /**
     * Setter for property dataTransformerManager.
     * @param dataTransformerManager New value of property dataTransformerManager.
     */
    public void setDataTransformerManager(String dataTransformerManager) {
        this.dataTransformerManager = dataTransformerManager;
    }


    /**
     * String representation for debug purposes
     *
     * @return the string representation of this object
     */
    public String toString() {
        StringBuffer buf = new StringBuffer();

        buf.append(getClass().getName())
           .append('@')
           .append(hashCode())
           .append("{\n")
           .append("serverURI: ").append(serverURI).append('\n')
           .append("strategy: ").append(strategy).append('\n')
           .append("sessionHandler: ").append(sessionHandler).append('\n')
           .append("store: ").append(store).append('\n')
           .append("deviceInventory: ").append(deviceInventory).append('\n')
           .append("loggingConfiguration: ").append(loggingConfiguration).append('\n')
           .append('}');

        return buf.toString();
    }
 }
