--
-- Initialization data for the Funambol Data Synchronization Server
--
-- @version $Id: init_engine.sql,v 1.1 2006/01/18 17:00:16 luigiafassina Exp $
--

--
-- FNBL_USER
--
insert into fnbl_user (username, password, email, first_name, last_name)
  values('guest', 'guest', 'guest@funambol.com', 'guest', 'guest');
  
insert into fnbl_user (username, password, email, first_name, last_name)
  values('admin', 'sa', 'admin@funambol.com', 'admin', 'admin');

--
-- FNBL_DEVICE
--
insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('syncml-phone', 'SyncML phone clients', 'Phone', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-pim-demo', 'Funambol Java GUI Plug-in Example', 'Java GUI Plug-in', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-pim-outlook', 'Funambol Outlook Plug-in', 'Outlook Plug-in', '', '', 'fnbl', -1, null, 'N', 'UTF-8');
  
insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-pim-blackberry', 'Funambol BlackBerry Plug-in', 'BlackBerry Plug-in', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-pim-palm', 'Funambol Palm Plug-in', 'Palm Plug-in', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-pim-ppc', 'Funambol PocketPC Plug-in', 'PocketPC Plug-in', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-pim-ipod', 'Funambol iPod Plug-in', 'iPod Plug-in', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-api-j2se', 'Funambol Java API J2SE', 'Java API J2SE', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-api-j2me', 'Funambol Java API J2ME', 'Java API J2ME', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

insert into fnbl_device (id, description, type, client_nonce, server_nonce, server_password, id_caps, timezone, convert_date, charset)
  values('sc-api-nat', 'Funambol C++ API', 'C++ API', '', '', 'fnbl', -1, null, 'N', 'UTF-8');

--
-- FNBL_PRINCIPAL
--
insert into fnbl_principal (id, username, device)
  values(1, 'guest', 'syncml-phone');
  
insert into fnbl_principal (id, username, device)
  values(2, 'guest', 'sc-pim-demo');

insert into fnbl_principal (id, username, device)
  values(3, 'guest','sc-pim-outlook');

insert into fnbl_principal (id, username, device)
  values(4, 'guest','sc-pim-blackberry');

insert into fnbl_principal (id, username, device)
  values(5, 'guest','sc-pim-palm');

insert into fnbl_principal (id, username, device)
  values(6, 'guest','sc-pim-ppc');

insert into fnbl_principal (id, username, device)
  values(7, 'guest','sc-api-j2se');

insert into fnbl_principal (id, username, device)
  values(8, 'guest','sc-api-j2me');

insert into fnbl_principal (id, username, device)
  values(9, 'guest','sc-api-nat');

insert into fnbl_principal (id, username, device)
  values(10, 'guest','sc-pim-ipod');

--
-- FNBL_ID
--
insert into fnbl_id values('device',0);

insert into fnbl_id values('principal',10);

insert into fnbl_id values('module',0);

insert into fnbl_id values('sourcetype',1);

insert into fnbl_id values('connector',0);

insert into fnbl_id values('guid',3);

insert into fnbl_id values('capability',0);

--
-- FNBL_ROLE
--
insert into fnbl_role values('sync_user','User');

insert into fnbl_role values('sync_administrator','Administrator');

--
-- FNBL_USER_ROLE
--
insert into fnbl_user_role values('guest','sync_user');

insert into fnbl_user_role values('admin','sync_administrator');
